
#include "HEAD.h"

#include "node.h"

#include "visitprocs.h"

#include "gsdescr.h"

extern void free();

extern char *malloc();

#include "obstack.h"

static struct obstack TreeSpace;

#define obstack_chunk_alloc malloc

#define obstack_chunk_free free

char* TreeNodeAlloc(size) int size;

{return (obstack_alloc(&TreeSpace, size));}

void InitTree() { obstack_init(&TreeSpace); }

NODEPTR Mkcardinal(_coordref,_tr1)
POSITION *_coordref;
INT _tr1;
{
_TSPcardinal n;
n = (_TSPcardinal) TreeNodeAlloc (sizeof (struct _TScardinal));
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;

n->_ATval=_tr1;
return ((NODEPTR) n);
}

NODEPTR Mkidentifier(_coordref,_tr1)
POSITION *_coordref;
SYMB _tr1;
{
_TSPidentifier n;
n = (_TSPidentifier) TreeNodeAlloc (sizeof (struct _TSidentifier));
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;

n->_ATid=_tr1;
return ((NODEPTR) n);
}

NODEPTR Mkstring(_coordref,_tr1)
POSITION *_coordref;
SYMB _tr1;
{
_TSPstring n;
n = (_TSPstring) TreeNodeAlloc (sizeof (struct _TSstring));
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;

n->_ATid=_tr1;
return ((NODEPTR) n);
}

NODEPTR MkStart_Rule(_coordref,_tr1,_tr2,_tr3,_tr4,_tr5)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
NODEPTR _tr4;
NODEPTR _tr5;
{_TPPStart_Rule n;
n = (_TPPStart_Rule) TreeNodeAlloc (sizeof (struct _TPStart_Rule));
n->_proc =_VS1Start_Rule;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPCODE_PART)_tr1;
n->_desc2= (_TSPSTOP_PART)_tr2;
n->_desc3= (_TSPERR_PART)_tr3;
n->_desc4= (_TSPMETA_PART)_tr4;
n->_desc5= (_TSPGRAMMAR_PART)_tr5;
return ( (NODEPTR) n);
}

NODEPTR MkCode_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPCode_1 n;
n = (_TPPCode_1) TreeNodeAlloc (sizeof (struct _TPCode_1));
n->_proc =_VS1Code_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPCODE_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkCode_2(_coordref)
POSITION *_coordref;
{_TPPCode_2 n;
n = (_TPPCode_2) TreeNodeAlloc (sizeof (struct _TPCode_2));
n->_proc =_VS1Code_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkCode_3(_coordref)
POSITION *_coordref;
{_TPPCode_3 n;
n = (_TPPCode_3) TreeNodeAlloc (sizeof (struct _TPCode_3));
n->_proc =_VS1Code_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkCode_4(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPCode_4 n;
n = (_TPPCode_4) TreeNodeAlloc (sizeof (struct _TPCode_4));
n->_proc =_VS1Code_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPCODE_LIST)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
n->_desc3= (_TSPcardinal)_tr3;
return ( (NODEPTR) n);
}

NODEPTR MkStop_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPStop_1 n;
n = (_TPPStop_1) TreeNodeAlloc (sizeof (struct _TPStop_1));
n->_proc =_VS1Stop_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkStop_2(_coordref)
POSITION *_coordref;
{_TPPStop_2 n;
n = (_TPPStop_2) TreeNodeAlloc (sizeof (struct _TPStop_2));
n->_proc =_VS1Stop_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkStop_3(_coordref)
POSITION *_coordref;
{_TPPStop_3 n;
n = (_TPPStop_3) TreeNodeAlloc (sizeof (struct _TPStop_3));
n->_proc =_VS1Stop_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_1(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPError_1 n;
n = (_TPPError_1) TreeNodeAlloc (sizeof (struct _TPError_1));
n->_proc =_VS1Error_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPSEPA_PART)_tr1;
n->_desc2= (_TSPBRACKET_PART)_tr2;
n->_desc3= (_TSPSKIP_PART)_tr3;
return ( (NODEPTR) n);
}

NODEPTR MkError_2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPError_2 n;
n = (_TPPError_2) TreeNodeAlloc (sizeof (struct _TPError_2));
n->_proc =_VS1Error_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPSEPA_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkError_3(_coordref)
POSITION *_coordref;
{_TPPError_3 n;
n = (_TPPError_3) TreeNodeAlloc (sizeof (struct _TPError_3));
n->_proc =_VS1Error_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_4(_coordref)
POSITION *_coordref;
{_TPPError_4 n;
n = (_TPPError_4) TreeNodeAlloc (sizeof (struct _TPError_4));
n->_proc =_VS1Error_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_5(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPError_5 n;
n = (_TPPError_5) TreeNodeAlloc (sizeof (struct _TPError_5));
n->_proc =_VS1Error_5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPSEPA_LIST)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkError_6(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPError_6 n;
n = (_TPPError_6) TreeNodeAlloc (sizeof (struct _TPError_6));
n->_proc =_VS1Error_6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPBRACKET_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkError_7(_coordref)
POSITION *_coordref;
{_TPPError_7 n;
n = (_TPPError_7) TreeNodeAlloc (sizeof (struct _TPError_7));
n->_proc =_VS1Error_7;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_8(_coordref)
POSITION *_coordref;
{_TPPError_8 n;
n = (_TPPError_8) TreeNodeAlloc (sizeof (struct _TPError_8));
n->_proc =_VS1Error_8;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_9(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPError_9 n;
n = (_TPPError_9) TreeNodeAlloc (sizeof (struct _TPError_9));
n->_proc =_VS1Error_9;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPBRACKET_LIST)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkError_10(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPError_10 n;
n = (_TPPError_10) TreeNodeAlloc (sizeof (struct _TPError_10));
n->_proc =_VS1Error_10;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPSKIP_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkError_11(_coordref)
POSITION *_coordref;
{_TPPError_11 n;
n = (_TPPError_11) TreeNodeAlloc (sizeof (struct _TPError_11));
n->_proc =_VS1Error_11;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_12(_coordref)
POSITION *_coordref;
{_TPPError_12 n;
n = (_TPPError_12) TreeNodeAlloc (sizeof (struct _TPError_12));
n->_proc =_VS1Error_12;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkError_13(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPError_13 n;
n = (_TPPError_13) TreeNodeAlloc (sizeof (struct _TPError_13));
n->_proc =_VS1Error_13;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPSKIP_LIST)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPMeta_1 n;
n = (_TPPMeta_1) TreeNodeAlloc (sizeof (struct _TPMeta_1));
n->_proc =_VS1Meta_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPMETA_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_2(_coordref)
POSITION *_coordref;
{_TPPMeta_2 n;
n = (_TPPMeta_2) TreeNodeAlloc (sizeof (struct _TPMeta_2));
n->_proc =_VS1Meta_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_3(_coordref)
POSITION *_coordref;
{_TPPMeta_3 n;
n = (_TPPMeta_3) TreeNodeAlloc (sizeof (struct _TPMeta_3));
n->_proc =_VS1Meta_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_4(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPMeta_4 n;
n = (_TPPMeta_4) TreeNodeAlloc (sizeof (struct _TPMeta_4));
n->_proc =_VS1Meta_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPMETA_LIST)_tr1;
n->_desc2= (_TSPNAME)_tr2;
n->_desc3= (_TSPTERMINAL_LIST)_tr3;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_5(_coordref)
POSITION *_coordref;
{_TPPMeta_5 n;
n = (_TPPMeta_5) TreeNodeAlloc (sizeof (struct _TPMeta_5));
n->_proc =_VS1Meta_5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_6(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPMeta_6 n;
n = (_TPPMeta_6) TreeNodeAlloc (sizeof (struct _TPMeta_6));
n->_proc =_VS1Meta_6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTERMINAL_LIST)_tr1;
n->_desc2= (_TSPMETA_TERMINAL)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkMeta_7(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPMeta_7 n;
n = (_TPPMeta_7) TreeNodeAlloc (sizeof (struct _TPMeta_7));
n->_proc =_VS1Meta_7;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkProd_1(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPProd_1 n;
n = (_TPPProd_1) TreeNodeAlloc (sizeof (struct _TPProd_1));
n->_proc =_VS1Prod_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPNAME)_tr1;
n->_desc2= (_TSPPROD_LIST)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkProd_2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPProd_2 n;
n = (_TPPProd_2) TreeNodeAlloc (sizeof (struct _TPProd_2));
n->_proc =_VS1Prod_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPPROD_LIST)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkProd_3(_coordref)
POSITION *_coordref;
{_TPPProd_3 n;
n = (_TPPProd_3) TreeNodeAlloc (sizeof (struct _TPProd_3));
n->_proc =_VS1Prod_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkProd_4(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPProd_4 n;
n = (_TPPProd_4) TreeNodeAlloc (sizeof (struct _TPProd_4));
n->_proc =_VS1Prod_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPPROD_LIST)_tr1;
n->_desc2= (_TSPPROD)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkProd_5(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPProd_5 n;
n = (_TPPProd_5) TreeNodeAlloc (sizeof (struct _TPProd_5));
n->_proc =_VS1Prod_5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
n->_desc2= (_TSPELEM)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkProd_6(_coordref,_tr1,_tr2,_tr3)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
NODEPTR _tr3;
{_TPPProd_6 n;
n = (_TPPProd_6) TreeNodeAlloc (sizeof (struct _TPProd_6));
n->_proc =_VS1Prod_6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPNAME)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
n->_desc3= (_TSPELEM)_tr3;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_1(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPRhs_1 n;
n = (_TPPRhs_1) TreeNodeAlloc (sizeof (struct _TPRhs_1));
n->_proc =_VS1Rhs_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
n->_desc2= (_TSPTorNT)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_2(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPRhs_2 n;
n = (_TPPRhs_2) TreeNodeAlloc (sizeof (struct _TPRhs_2));
n->_proc =_VS1Rhs_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
n->_desc2= (_TSPELEM)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_3(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPRhs_3 n;
n = (_TPPRhs_3) TreeNodeAlloc (sizeof (struct _TPRhs_3));
n->_proc =_VS1Rhs_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
n->_desc2= (_TSPELEM)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_4(_coordref)
POSITION *_coordref;
{_TPPRhs_4 n;
n = (_TPPRhs_4) TreeNodeAlloc (sizeof (struct _TPRhs_4));
n->_proc =_VS1Rhs_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_5(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_5 n;
n = (_TPPRhs_5) TreeNodeAlloc (sizeof (struct _TPRhs_5));
n->_proc =_VS1Rhs_5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_6(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_6 n;
n = (_TPPRhs_6) TreeNodeAlloc (sizeof (struct _TPRhs_6));
n->_proc =_VS1Rhs_6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_7(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_7 n;
n = (_TPPRhs_7) TreeNodeAlloc (sizeof (struct _TPRhs_7));
n->_proc =_VS1Rhs_7;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPELEM)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_8(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_8 n;
n = (_TPPRhs_8) TreeNodeAlloc (sizeof (struct _TPRhs_8));
n->_proc =_VS1Rhs_8;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_9(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_9 n;
n = (_TPPRhs_9) TreeNodeAlloc (sizeof (struct _TPRhs_9));
n->_proc =_VS1Rhs_9;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPCONNECTION)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_10(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_10 n;
n = (_TPPRhs_10) TreeNodeAlloc (sizeof (struct _TPRhs_10));
n->_proc =_VS1Rhs_10;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkRhs_11(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRhs_11 n;
n = (_TPPRhs_11) TreeNodeAlloc (sizeof (struct _TPRhs_11));
n->_proc =_VS1Rhs_11;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTorNT)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkSymbol_1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPSymbol_1 n;
n = (_TPPSymbol_1) TreeNodeAlloc (sizeof (struct _TPSymbol_1));
n->_proc =_VS1Symbol_1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPidentifier)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkSymbol_2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPSymbol_2 n;
n = (_TPPSymbol_2) TreeNodeAlloc (sizeof (struct _TPSymbol_2));
n->_proc =_VS1Symbol_2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPidentifier)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkSymbol_3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPSymbol_3 n;
n = (_TPPSymbol_3) TreeNodeAlloc (sizeof (struct _TPSymbol_3));
n->_proc =_VS1Symbol_3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPstring)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkSymbol_4(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPSymbol_4 n;
n = (_TPPSymbol_4) TreeNodeAlloc (sizeof (struct _TPSymbol_4));
n->_proc =_VS1Symbol_4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPstring)_tr1;
return ( (NODEPTR) n);
}

#ifndef GETcardinalval
#define GETcardinalval(x) (x)
#endif

#ifndef GETidentifierid
#define GETidentifierid(x) (x)
#endif

#ifndef GETstringid
#define GETstringid(x) (x)
#endif

void SourceLeaf(d) GRUNDSYMBOLDESKRIPTOR *d;
{_incrnodestack ();
switch (d->SyntaxCode) {

case 2: _nst[_nsp] =Mkcardinal(&(d->Pos),GETcardinalval (d->Attr)); break;

case 3: _nst[_nsp] =Mkidentifier(&(d->Pos),GETidentifierid (d->Attr)); break;

case 4: _nst[_nsp] =Mkstring(&(d->Pos),GETstringid (d->Attr)); break;
}}

